#include "ParamInteger.h"
#include "Utils.h"

namespace ffgl
{

ParamInteger::ParamInteger( const std::string& name, int defaultValue, const RangeStruct range ) :
	ParamRange( name, ParameterType::FF_TYPE_INTEGER, static_cast< float >( defaultValue ), range )
{
}

const std::string& ParamInteger::GetDisplay() const
{
	return std::to_string( GetIntegerValue() );
}

int ParamInteger::GetIntegerValue() const
{
	return static_cast< int >( GetRealValue() );
}

void ParamInteger::SetIntegerValue( int newValue )
{
	value = utils::map( static_cast< float >( newValue ), range.min, range.max, 0.0f, 1.0f );
}

}//End namespace ffgl