#include "ParamText.h"

namespace ffgl
{

ParamText::ParamText( const std::string& name, const std::string& defaultText) :
	ParamBase( name, ParameterType::FF_TYPE_TEXT ),
	text( defaultText ),
	defaultText( defaultText )
{
}

ParamText::~ParamText()
{
}

void ParamText::Reset()
{
	SetText( GetDefaultText() );
}

const std::string& ParamText::GetDisplay() const
{
	return GetText();
}

FFMixed ParamText::GetMixedDefault() const
{
	FFMixed retval;
	retval.StrValue = GetText().c_str();
	return retval;
}

FFMixed ParamText::GetMixedValue() const
{
	FFMixed retval;
	retval.StrValue = GetText().c_str();
	return retval;
}

FFResult ParamText::SetMixedValue( const FFMixed mixed )
{
	SetText( std::string( mixed.StrValue ) );
	return FF_SUCCESS;
}

const std::string& ParamText::GetDefaultText() const
{
	return defaultText;
}

const std::string& ParamText::GetText() const
{
	return text;
}

void ParamText::SetText( const std::string& textValue )
{
	text = textValue;
}

}//End namespace ffgl
